////////////////////////////////////
// core.h
// Common stuff
// Original coding by Pascal Gautron, July 2006
////////////////////////////////////


#ifndef _CORE_H_
#define _CORE_H_

#ifdef WIN32
#include <windows.h>
#define _USE_MATH_DEFINES
#endif //WIN32
#include <iostream>
#include <math.h>
#include <conio.h>
#include <IL/il_wrap.h>

inline int PressAnyKey()
{
  std::cout << "Press any key to continue..." << std::endl;
  return getch();
}
#define INFO(msg) { std::cout << msg << std::endl;} 
#ifndef STATUS
#define STATUS std::cout
#define ENDL std::endl
#define FLUSH std::flush
#endif // STATUS

#define FATAL(msg) { std::cerr << "Fatal error: " << msg << std::endl; PressAnyKey(); exit(-1);} 
#define WARNING(msg) { std::cerr << "Warning: " << msg << std::endl;} 

#ifndef PRINTVAR
#define PRINTVAR(a) std::cerr << #a"\t" << a << std::endl;

/// Display a 3D vector contents
#define PRINTV3D(v) {INFO(#v << " = (" << v[0] << ", " << v[1] << ", " << v[2] << ")");}
#define PRINTV4D(v) {INFO(#v << " = (" << v[0] << ", " << v[1] << ", " << v[2] << ", " << v[3] << ")");}
#define PRINTARRAY(l, v) {std::cout << #v << " = "; for (int PRINTARRAYINDEX=0; PRINTARRAYINDEX< l; PRINTARRAYINDEX++) { std::cout << v[PRINTARRAYINDEX] << ", ";} std::cout << std::endl;}
/// Display a 4x4 matrix contents
#define PRINTM4X4(m) {INFO(#m << " = (" << m[0] << ", " << m[1] << ", " << m[2] << ", " << m[3] << ")");INFO(#m << " = (" << m[4] << ", " << m[5] << ", " << m[6] << ", " << m[7] << ")");INFO(#m << " = (" << m[8] << ", " << m[9] << ", " << m[10] << ", " << m[11] << ")");INFO(#m << " = (" << m[12] << ", " << m[13] << ", " << m[14] << ", " << m[15] << ")");}

#endif // PRINTVAR

#endif //_CORE_H_