////////////////////////////////////
// raycasting.h
// Raycasting-based volume renderer
// Original coding by Pascal Gautron, July 2006
////////////////////////////////////



#ifndef _RAYCASTING_H_
#define _RAYCASTING_H_
#include <volumerenderer.h>
extern float d, theta, phi;
class CRayCasting : public CVolumeRenderer
{
public:
  CRayCasting():_shader(NULL) {}
  virtual ~CRayCasting() {}

  virtual bool LoadData(const char *baseName, const char *extension, int numberOfFiles, int digits);
  virtual void Render();
private:
  C3DTexture<unsigned char> _3dTex;
  GLuint _texID;
  int _depth;
  char _tmpFileName[256];
  const char *GenFileName(const char *baseName, const char *extension, int id, int digits);
  void DrawCube() const;
  CShader *_shader;
};


#endif //_RAYCASTING_H_