////////////////////////////////////
// shearwarp.h
// Shear warp rendering
// Original coding by Pascal Gautron, August 2006
////////////////////////////////////



#ifndef _SHEARWARP_H_
#define _SHEARWARP_H_
#include <volumerenderer.h>
#include <perftimer.h>
#include <matrix.h>
extern float d, theta, phi;
class CShearWarp : public CVolumeRenderer
{
public:
  CShearWarp();
  virtual ~CShearWarp() {}

  
  virtual void Render();

  virtual void Menu(int item);
  virtual void CreateMenus();

  virtual void Key(unsigned char key, int x, int y);
  virtual bool LoadData(const char *iniFile);

private:
  virtual bool LoadData(const char *baseName, const char *extension, int numberOfFiles, int digits, int start);
  void ComputeGradientsCPU(int width, int height, int depth);
  void ComputeGradientsGPU(int width, int height, int depth);
  void DisplayInfoPanel();

  float _threshold;

  int _start;

  C3DTexture<unsigned char> _3dTex;
  GLuint _texID;
  int _depth;
  char _tmpFileName[256];
  const char *GenFileName(const char *baseName, const char *extension, int id, int digits);
  void DrawShearsXY() const;

  CShader *_shader;
  CFBO *_fbo;
  float _curTexMatrix[16];
  int _sampling;

  C3DTexture<unsigned char> _normalTex;
  //C3DTexture<float> _normalTex;
  GLuint _normalTexID;

  char slicing[255];

  CPerfTimer _timer;
  int _frameCounter;
  float _fps;
  bool _infoPanel;
};


#endif //_SHEARWARP_H_